﻿#pragma once

#include <cigui/config.h>
#include <LLGL/LLGL.h>

#include <cigui/utils/List.hpp>

namespace cig
{
	struct Vertex
	{
		float position[2]; // 2D vector for X and Y coordinates
		uint8_t color[4]; // 4D vector for red, green, blue, and alpha components
	};

	class App
	{
	protected:
		App();
		~App();

		LLGL::RenderSystemPtr m_RenderSystem;
		LLGL::SwapChain* m_SwapChain;

		std::pair<LLGL::Shader*, LLGL::Shader*> m_ShaderPack;
		LLGL::PipelineState* m_Pipeline;
		LLGL::Buffer* m_VertexBuffer;
		LLGL::CommandBuffer* m_CmdBuffer;
		LLGL::Window* m_Window;

		bool ShaderLanguageIsSupported(LLGL::ShadingLanguage lang);

		List<Vertex> m_Vertices;
	public:
		static App& GetInstance();

		void Run();
	};
}
